unit MCKMHVersionInfo;
//  VersionInfo 
//  :  
//   : 2002--14
//   : 2002--17
//  : 0.9
//  EMail: Gendalf_the_gr@mail.ru
//  WWW: http://delphisoft.boom.ru
//  TODO List
//  Add Languages
//  Add Encode Languages
//  Add SubTypes
//  New in
//  V0.2
//  +Add Template
//  +Add Minor,Major,Release,Build
//  +Add OS Type
//  +Add FileFlags
//  +Add FileType
//  V0.9
//  +Add Language Infos
//  +Add Create Defaults

interface

uses
  KOL, KOLMHVersionInfo, mirror, mckObjs, Classes, Graphics,Windows,Forms,ComCtrls;

type
  TKOLMHVersionInfo=class;

  TLanguage=(Russian);

  TLangInfo = class(TCollectionItem)
  private
    FLanguage:TLanguage;
    FComments:String;
    FCompanyName:String;
    FFileDescription:String;
    FFileVersion:String;
    FInternalName:String;
    FLegalCopyRight:String;
    FLegalTrademarks:String;
    FOriginalFileName:String;
    FPrivateBuild:String;
    FProductName:String;
    FProductVersion:String;
    FSpecialBuild:String;
    procedure SetLanguage(const Value:TLanguage);
    procedure SetComments(const Value:String);
    procedure SetCompanyName(const Value:String);
    procedure SetFileDescription(const Value:String);
    procedure SetInternalName(const Value:String);
    procedure SetFileVersion(const Value:String);
    procedure SetLegalCopyRight(const Value:String);
    procedure SetLegalTrademarks(const Value:String);
    procedure SetOriginalFileName(const Value:String);
    procedure SetPrivateBuild(const Value:String);
    procedure SetProductName(const Value:String);
    procedure SetProductVersion(const Value:String);
    procedure SetSpecialBuild(const Value:String);
  protected
  public
    constructor Create(Collection: TCollection); override;
    procedure Assign(Source: TPersistent); override;
  published
    property Language:TLanguage read FLanguage write SetLanguage;
    property Comments:String read FComments write SetComments;
    property CompanyName:String read FCompanyName write SetCompanyName;
    property FileDescription:String read FFileDescription write SetFileDescription;
    property FileVersion:String read FFileVersion write SetFileVersion;
    property InternalName:String read FInternalName write SetInternalName;
    property LegalCopyRight:String read FLegalCopyRight write SetLegalCopyRight;
    property LegalTrademarks:String read FLegalTrademarks write SetLegalTrademarks;
    property OriginalFileName:String read FOriginalFileName write SetOriginalFileName;
    property PrivateBuild:String read FPrivateBuild write SetPrivateBuild;
    property ProductName:String read FProductName write SetProductName;
    property ProductVersion:String read FProductVersion write SetProductVersion;
    property SpecialBuild:String read FSpecialBuild write SetSpecialBuild;
  end;

  TLangInfos = class(TCollection)
  private
    FKOLMHVersionInfo: TKOLMHVersionInfo;
    function GetItem(Index: Integer): TLangInfo;
    procedure SetItem(Index: Integer; Value: TLangInfo);
  protected
    function GetOwner: TPersistent; override;
//    procedure Update(Item: TCollectionItem); override;
  public
    constructor Create(KOLMHVersionInfo: TKOLMHVersionInfo);
    function Add: TLangInfo;
    property Items[Index: Integer]: TLangInfo read GetItem write SetItem; default;
  end;

  TOS=(VOS_UNKNOWN,VOS_DOS,VOS_OS216,VOS_OS232,VOS_NT,VOS_WINDOWS16,
  VOS_PM16,VOS_PM32,VOS_WINDOWS32,VOS_DOS_WINDOWS16,VOS_DOS_WINDOWS32,VOS_OS216_PM16,
  VOS_OS232_PM32,VOS_NT_WINDOWS32);

  TFileFlag=(VS_FF_DEBUG,VS_FF_PRELEASE,VS_FF_PATCHED,VS_FF_PRIVATEBUILD,
  VS_FF_INFOINFERRED,VS_FF_SPECIALBUILD);

  TFileFlags=set of TFileFlag;

  TFileType=(VFT_UNKNOWN,VFT_APP,VFT_DLL,VFT_DRV,VFT_FONT,VFT_VXD,VFT_STSTIC_LIB);

  TKOLMHVersionInfo = class(TKOLObj)
  private
     FMajorVersion:Word;
     FMinorVersion:Word;
     FRelease:Word;
     FBuild:Word;
     FOS:TOS;
     FFileFlags:TFileFlags;
     FFileType:TFileType;
     FLangInfos:TLangInfos;
     procedure SetMajorVersion(const Value:Word);
     procedure SetMinorVersion(const Value:Word);
     procedure SetRelease(const Value:Word);
     procedure SetBuild(const Value:Word);
     procedure SetOS(const Value:TOS);
     procedure SetFileFlags(const Value:TFileFlags);
     procedure SetFileType(const Value:TFileType);
     procedure SetLangInfos(Value: TLangInfos);
  protected
    function  AdditionalUnits: string; override;
    procedure SetupFirst(SL: TStringList; const AName,AParent, Prefix: String); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property MajorVersion:Word read FMajorVersion  write SetMajorVersion;
    property MinorVersion:Word read FMinorVersion write SetMinorVersion;
    property Release:Word read FRelease write SetRelease;
    property Build:Word read FBuild write SetBuild;
    property OS:TOS read FOS write SetOS;
    property FileFlags:TFileFlags read FFileFlags write SetFileFlags;
    property FileType:TFileType read FFileType write SetFileType;
    property LangInfos:TLangInfos read FLangInfos write SetLangInfos;
  end;

  procedure Register;

implementation

constructor TLangInfo.Create(Collection: TCollection);
begin
  FLanguage:=Russian;
  FComments:='Comments';
  FCompanyName:='Your Company Name';
  FFileDescription:='File Description';
  FFileVersion:='1, 1, 1, 1';
  FInternalName:='Your Application Name ';
  FLegalCopyRight:='Copyright  2002';
  FLegalTrademarks:='Your TradeMarks';
  FOriginalFileName:='File Name';
  FPrivateBuild:='Private Build';
  FProductName:='Your Product Name';
  FProductVersion:='1, 1, 1, 1';
  FSpecialBuild:='Special Build';
  inherited Create(Collection);
end;

procedure TLangInfo.Assign(Source: TPersistent);
begin
  if Source is TLangInfo then
  begin
    Comments:=TLangInfo(Source).Comments;
    Language:=TLangInfo(Source).Language;
    CompanyName:=TLangInfo(Source).CompanyName;
    FileDescription:=TLangInfo(Source).FileDescription;
    FileVersion:=TLangInfo(Source).FileVersion;
    InternalName:=TLangInfo(Source).InternalName;
    LegalCopyRight:=TLangInfo(Source).LegalCopyRight;
    LegalTrademarks:=TLangInfo(Source).LegalTrademarks;
    OriginalFileName:=TLangInfo(Source).OriginalFileName;
    PrivateBuild:=TLangInfo(Source).PrivateBuild;
    ProductName:=TLangInfo(Source).ProductName;
    ProductVersion:=TLangInfo(Source).ProductVersion;
    SpecialBuild:=TLangInfo(Source).SpecialBuild;
  end
  else inherited Assign(Source);
end;

procedure TLangInfo.SetLanguage(const Value:TLanguage);
begin
  if FLanguage<>Value then
  begin
    FLanguage:=Value;
  end;
end;

procedure TLangInfo.SetComments(const Value:String);
begin
  if FComments<>Value then
  begin
    FComments:=Value;
  end;
end;

procedure TLangInfo.SetFileDescription(const Value:String);
begin
  if FFileDescription<>Value then
  begin
    FFileDescription:=Value;
  end;
end;

procedure TLangInfo.SetCompanyName(const Value:String);
begin
  if FCompanyName<>Value then
  begin
    FCompanyName:=Value;
  end;
end;

procedure TLangInfo.SetFileVersion(const Value:String);
begin
  if FFileVersion<>Value then
  begin
    FFileVersion:=Value;
  end;
end;

procedure TLangInfo.SetInternalName(const Value:String);
begin
  if FInternalName<>Value then
  begin
    FInternalName:=Value;
  end;
end;

procedure TLangInfo.SetLegalCopyRight(const Value:String);
begin
  if FLegalCopyRight<>Value then
  begin
    FLegalCopyRight:=Value;
  end;
end;

procedure TLangInfo.SetLegalTrademarks(const Value:String);
begin
  if FLegalTrademarks<>Value then
  begin
    FLegalTrademarks:=Value;
  end;
end;

procedure TLangInfo.SetOriginalFileName(const Value:String);
begin
  if FOriginalFileName<>Value then
  begin
    FOriginalFileName:=Value;
  end;
end;

procedure TLangInfo.SetPrivateBuild(const Value:String);
begin
  if FPrivateBuild<>Value then
  begin
    FPrivateBuild:=Value;
  end;
end;

procedure TLangInfo.SetProductName(const Value:String);
begin
  if FProductName<>Value then
  begin
    FProductName:=Value;
  end;
end;

procedure TLangInfo.SetProductVersion(const Value:String);
begin
  if FProductVersion<>Value then
  begin
    FProductVersion:=Value;
  end;
end;

procedure TLangInfo.SetSpecialBuild(const Value:String);
begin
  if FSpecialBuild<>Value then
  begin
    FSpecialBuild:=Value;
  end;
end;

constructor TLangInfos.Create(KOLMHVersionInfo: TKOLMHVersionInfo);
begin
  inherited Create(TLangInfo);
  FKOLMHVersionInfo:=KOLMHVersionInfo;
end;

function TLangInfos.Add:TLangInfo;
begin
  Result := TLangInfo(inherited Add);
  FKOLMHVersionInfo.Change;
end;

function TLangInfos.GetItem(Index: Integer): TLangInfo;
begin
  Result := TLangInfo(inherited GetItem(Index));
  FKOLMHVersionInfo.Change;
end;

function TLangInfos.GetOwner: TPersistent;
begin
  Result := FKOLMHVersionInfo;
end;

procedure TLangInfos.SetItem(Index: Integer; Value: TLangInfo);
begin
  inherited SetItem(Index, Value);
  FKOLMHVersionInfo.Change;
end;

{procedure TLangInfos.Update(Item: TCollectionItem);
begin
//  if Item <> nil then
//    FKOLMHVersionInfo.UpdatePanel(Item.Index, False) else
//    FKOLMHVersionInfo.UpdatePanels(True, False);
end;                  }

function FileType2Str(FileType:TFileType):String;
begin
  case FileType of
    VFT_UNKNOWN: Result:=Int2Str($0);
    VFT_APP: Result:=Int2Str($1);
    VFT_DLL: Result:=Int2Str($2);
    VFT_DRV: Result:=Int2Str($3);
    VFT_FONT: Result:=Int2Str($4);
    VFT_VXD: Result:=Int2Str($5);
    VFT_STSTIC_LIB: Result:=Int2Str($7);
  end;  //case
end;

function FileFlags2Str(FileFlags:TFileFlags):String;
var
  Flag:DWord;
begin
  Flag:=0;
  if VS_FF_DEBUG in FileFlags then
    Flag:=Flag or $01;
  if VS_FF_PRELEASE in FileFlags then
    Flag:=Flag or $02;
  if VS_FF_PATCHED in FileFlags then
    Flag:=Flag or $04;
  if VS_FF_PRIVATEBUILD in FileFlags then
    Flag:=Flag or $08;
  if VS_FF_INFOINFERRED in FileFlags then
    Flag:=Flag or $10;
  if VS_FF_SPECIALBUILD in FileFlags then
    Flag:=Flag or $20;
  Result:=Int2Str(Flag);
end;

function OS2Str(OS:TOS):String;
begin
  case OS of
    VOS_UNKNOWN: Result:=Int2Str($0);
    VOS_DOS: Result:=Int2Str($10000);
    VOS_OS216: Result:=Int2Str($20000);
    VOS_OS232: Result:=Int2Str($30000);
    VOS_NT: Result:=Int2Str(40000);
    VOS_WINDOWS16: Result:=Int2Str($1);
    VOS_PM16: Result:=Int2Str($2);
    VOS_PM32: Result:=Int2Str($3);
    VOS_WINDOWS32: Result:=Int2Str($4);
    VOS_DOS_WINDOWS16: Result:=Int2Str($10001);
    VOS_DOS_WINDOWS32: Result:=Int2Str($10004);
    VOS_OS216_PM16: Result:=Int2Str($20002);
    VOS_OS232_PM32: Result:=Int2Str($30003);
    VOS_NT_WINDOWS32: Result:=Int2Str($40004);
  end;  //case
end;

procedure GenerateVersionResource( MajorVersion,MinorVersion,Release,Build:Word; FileFlags:TFileFlags; OS:TOS; FileType:TFileType; LangInfos:TLangInfos;
const RsrcName, FileName: String;
          var Updated: Boolean );
var RL: TStringList;
    Buf1, Buf2: PChar;
    S: String;
    I, J: Integer;
    F: THandle;
    TransationStr:String;
begin
  RL := TStringList.Create;
  RL.Add( 'VS_VERSION_INFO VERSIONINFO' );
  RL.Add( 'FILEVERSION '+Int2Str(MajorVersion)+','+Int2Str(MinorVersion)+','+Int2Str(Release)+','+Int2Str(Build) );
  RL.Add( 'PRODUCTVERSION 1,0,0,1' );
  RL.Add( 'FILEFLAGSMASK 0x3fL' );
  RL.Add( 'FILEFLAGS '+FileFlags2Str(FileFlags) );
  RL.Add( 'FILEOS '+OS2Str(OS) );
  RL.Add( 'FILETYPE '+FileType2Str(FileType) );
  RL.Add( 'FILESUBTYPE 0x0L' );
  if LangInfos.Count<>0 then
  begin
    RL.Add( 'BEGIN' );
    RL.Add( '  BLOCK "StringFileInfo"' );
    RL.Add( '  BEGIN' );
  end;
  For i:=0 to LangInfos.Count-1 do
  begin
    with LangInfos[i] do
    begin
      RL.Add( '      BLOCK "041904b0"' );
      RL.Add( '      BEGIN' );
      if Comments<>'' then
        RL.Add( '          VALUE "Comments", "'+Comments+'\0"' );
      if CompanyName<>'' then
        RL.Add( '          VALUE "CompanyName", "'+CompanyName+'\0"' );
      if FileDescription<>'' then
        RL.Add( '          VALUE "FileDescription", "'+FileDescription+'\0"' );
      if FileVersion<>'' then
        RL.Add( '          VALUE "FileVersion", "'+FileVersion+'\0"' );
      if InternalName<>'' then
        RL.Add( '          VALUE "InternalName", "'+InternalName+'\0"' );
      if LegalCopyright<>'' then
        RL.Add( '          VALUE "LegalCopyright", "'+LegalCopyright+'\0"' );
      if LegalTrademarks<>'' then
        RL.Add( '          VALUE "LegalTrademarks", "'+LegalTrademarks+'\0"' );
      if OriginalFilename<>'' then
        RL.Add( '          VALUE "OriginalFilename", "'+OriginalFilename+'\0"' );
      if PrivateBuild<>'' then
        RL.Add( '          VALUE "PrivateBuild", "'+PrivateBuild+'\0"' );
      if ProductName<>'' then
        RL.Add( '          VALUE "ProductName", "'+ProductName+'\0"' );
      if ProductVersion<>'' then
        RL.Add( '          VALUE "ProductVersion", "'+ProductVersion+'\0"' );
      if SpecialBuild<>'' then
        RL.Add( '          VALUE "SpecialBuild", "'+SpecialBuild+'\0"' );
      RL.Add( '      END' );
    end;
  end;
  if LangInfos.Count<>0 then
  begin
    RL.Add( '  END' );
    RL.Add( '  BLOCK "VarFileInfo"' );
    RL.Add( '  BEGIN' );
    TransationStr:='';
    For i:=0 to LangInfos.Count-1 do
      TransationStr:=TransationStr+', 0x419, 1200';
    RL.Add( '      VALUE "Translation"'+TransationStr );
    RL.Add( '  END' );
    RL.Add( 'END' );
  end;


  RL.SaveToFile( ProjectSourcePath + FileName + '.rc' );
  RL.Free;
  Buf1 := nil;
  Buf2 := nil;
  I := 0; J := 0;
  S := ProjectSourcePath + FileName + '.res';
  if FileExists( S ) then
  begin
    I := FileSize( S );
    if I > 0 then
    begin
      GetMem( Buf1, I );
      F := KOL.FileCreate( S, ofOpenRead or ofShareDenyWrite or ofOpenExisting );
      if F <> THandle( -1 ) then
      begin
        KOL.FileRead( F, Buf1^, I );
        KOL.FileClose( F );
      end;
    end;
  end;
  {ShellExecute( 0, 'open', PChar( ExtractFilePath( Application.ExeName ) + 'brcc32.exe' ),
                PChar( ProjectSourcePath + FileName + '.rc' ), PChar( ProjectSourcePath ),
                SW_HIDE );}
  ExecuteWait( ExtractFilePath( Application.ExeName ) + 'brcc32.exe',
  '"'+ProjectSourcePath + FileName + '.rc'+'"',ProjectSourcePath, SW_HIDE, INFINITE, nil );
  if FileExists( S ) then
  begin
    J := FileSize( S );
    if J > 0 then
    begin
      GetMem( Buf2, J );
      F := KOL.FileCreate( S, ofOpenRead or ofShareDenyWrite or ofOpenExisting );
      if F <> THandle( -1 ) then
      begin
        KOL.FileRead( F, Buf2^, J );
        KOL.FileClose( F );
      end;
    end;
  end;
  if (Buf1 = nil) or (I <> J) or
     (Buf2 <> nil) and not CompareMem( Buf1, Buf2, J ) then
  begin
    Updated := TRUE;
  end;
  if Buf1 <> nil then FreeMem( Buf1 );
  if Buf2 <> nil then FreeMem( Buf2 );
end;

constructor TKOLMHVersionInfo.Create(AOwner: TComponent);
begin
  inherited;
  FLangInfos := TLangInfos.Create(Self);
  FMajorVersion:=1;
  FMinorVersion:=1;
  FRelease:=1;
  FBuild:=1;
  FOS:=VOS_WINDOWS32;
  FFileFlags:=[];
  FFileType:=VFT_APP;
end;

destructor TKOLMHVersionInfo.Destroy;
begin
  inherited;
end;

function TKOLMHVersionInfo.AdditionalUnits;
begin
  Result := ', KOLMHVersionInfo';
end;

procedure TKOLMHVersionInfo.SetupFirst(SL: TStringList; const AName,
  AParent, Prefix: String);
var RsrcName, RsrcFile: String;
begin
  RsrcName := UpperCase( 'MH' + ParentKOLForm.FormName + '_' + Name );
  RsrcFile := 'Version';
  SL.Add( Prefix + '  {$R ' + RsrcFile + '.RES}' );
  GenerateVersionResource( FMajorVersion,FMinorVersion,FRelease,FBuild, FFileFlags,FOS,FFileType, FLangInfos, RsrcName, RsrcFile, fUpdated );
end;

procedure TKOLMHVersionInfo.SetMajorVersion(const Value:Word);
begin
  FMajorVersion:=Value;
  Change;
end;

procedure TKOLMHVersionInfo.SetMinorVersion(const Value:Word);
begin
  FMinorVersion:=Value;
  Change;
end;

procedure TKOLMHVersionInfo.SetRelease(const Value:Word);
begin
  FRelease:=Value;
  Change;
end;

procedure TKOLMHVersionInfo.SetBuild(const Value:Word);
begin
  FBuild:=Value;
  Change;
end;

procedure TKOLMHVersionInfo.SetOS(const Value:TOS);
begin
  FOS:=Value;
  Change;
end;

procedure TKOLMHVersionInfo.SetFileFlags(const Value:TFileFlags);
begin
  FFileFlags:=Value;
  Change;
end;

procedure TKOLMHVersionInfo.SetFileType(const Value:TFileType);
begin
  FFileType:=Value;
  Change;
end;

procedure TKOLMHVersionInfo.SetLangInfos(Value: TLangInfos);
begin
  FLangInfos.Assign(Value);
  Change;
end;

procedure Register;
begin
  RegisterComponents('KOL', [TKOLMHVersionInfo]);
end;

end.

